// ################################################################################################################################################################# //
// ###                                                          STEROWNIK SEGMENTU NR 3 MAKIETY "STACJA WYSOKA"
// ###
// ###                                                                                                                                          Klaudiusz Dawid 2020
// ################################################################################################################################################################# //



#include <Servo.h>
Servo serwo_5;

#define przekaznik_5      3

#define F_czerwone        5
#define F_zielone         6
#define F_pomaranczowe_1  7
#define F_pomaranczowe_2  8
#define F_biale           9

#define D_biale           10
#define D_zielone         11
#define D_czerwone        12

#define E_czerwone        A0
#define E_zielone         A1
#define E_pomaranczowe    A2
#define E_biale           A3


int data;
int pozycja_serwo_5 = 20;
int migacz = 0;
int miganie_pomaranczowe_F = 0;
int miganie_biale_D = 0;
int miganie_biale_E = 0;
int miganie_biale_F = 0;
unsigned long czas;
unsigned long czas_miganie = 1000;



// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   S E T U P   ----------------------------------------------------------------------
void setup() {
  Serial.begin(9600);

  serwo_5.attach(2);
  serwo_5.write(20);  // pozycja na wprost //

  pinMode(przekaznik_5, OUTPUT);
  digitalWrite(przekaznik_5, LOW);

  pinMode(F_czerwone, OUTPUT);
  pinMode(F_zielone, OUTPUT);
  pinMode(F_pomaranczowe_1, OUTPUT);
  pinMode(F_pomaranczowe_2, OUTPUT);
  pinMode(F_biale, OUTPUT);
  digitalWrite(F_czerwone, HIGH);
  digitalWrite(F_zielone, LOW);
  digitalWrite(F_pomaranczowe_1, LOW);
  digitalWrite(F_pomaranczowe_2, LOW);
  digitalWrite(F_biale, LOW);

  pinMode(D_biale, OUTPUT);
  pinMode(D_zielone, OUTPUT);
  pinMode(D_czerwone, OUTPUT);
  digitalWrite(D_biale, LOW);
  digitalWrite(D_zielone, LOW);
  digitalWrite(D_czerwone, HIGH);

  pinMode(E_czerwone, OUTPUT);
  pinMode(E_zielone, OUTPUT);
  pinMode(E_pomaranczowe, OUTPUT);
  pinMode(E_biale, OUTPUT);
  digitalWrite(E_czerwone, HIGH);
  digitalWrite(E_zielone, LOW);
  digitalWrite(E_pomaranczowe, LOW);
  digitalWrite(E_biale, LOW);

} // koniec bloku setup //




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------   O D C Z Y T   S E R I A L A   ----------------------------------------------------------------
void odczyt_seriala()
{
  data = Serial.parseInt();
  delay(10);

  if (data == 3012)                         // serwo 5 na bok //
  {
    if (pozycja_serwo_5 <= 21)
    {
      for (pozycja_serwo_5 = 20; pozycja_serwo_5 <= 100; pozycja_serwo_5 ++ )
      {
        serwo_5.write(pozycja_serwo_5);
        delay(10);
        if (pozycja_serwo_5 > 60) digitalWrite(przekaznik_5, HIGH);
        if (pozycja_serwo_5 > 98) Serial.println(6011);
      }
    }
  } // 3012 //


  if (data == 3011)                         // serwo 5 na wprost //
  {
    if (pozycja_serwo_5 >= 98)
    {
      for (pozycja_serwo_5 = 100; pozycja_serwo_5 >= 20; pozycja_serwo_5 -- )
      {
        serwo_5.write(pozycja_serwo_5);
        delay(10);
        if (pozycja_serwo_5 < 60) digitalWrite(przekaznik_5, LOW);
        if (pozycja_serwo_5 < 22) Serial.println(6012);
      }
    }
  } // 3011 //

  // ------------------------------------------- SEMAFOR D ---------------------------- //
  if (data == 3021)     // D czerwone //
  {
    digitalWrite(D_czerwone, HIGH);
    digitalWrite(D_zielone, LOW);
    digitalWrite(D_biale, LOW);
    miganie_biale_D = 0;
    Serial.println(6021);
  }

  if (data == 3022)     // D zielone //
  {
    digitalWrite(D_czerwone, LOW);
    digitalWrite(D_zielone, HIGH);
    digitalWrite(D_biale, LOW);
    miganie_biale_D = 0;
    Serial.println(6022);
  }

  if (data == 3023)     // D biale //
  {
    digitalWrite(D_czerwone, HIGH);
    digitalWrite(D_zielone, LOW);
    digitalWrite(D_biale, HIGH);
    miganie_biale_D = 1;
    Serial.println(6023);
  }


  // ------------------------------------------- SEMAFOR E ---------------------------- //
  if (data == 3031)     // E czerwone //
  {
    digitalWrite(E_czerwone, HIGH);
    digitalWrite(E_zielone, LOW);
    digitalWrite(E_pomaranczowe, LOW);
    digitalWrite(E_biale, LOW);
    miganie_biale_E = 0;
    Serial.println(6031);
  }

  if (data == 3032)     // E zielone //
  {
    digitalWrite(E_czerwone, LOW);
    digitalWrite(E_zielone, HIGH);
    digitalWrite(E_pomaranczowe, LOW);
    digitalWrite(E_biale, LOW);
    miganie_biale_E = 0;
    Serial.println(6032);
  }

  if (data == 3033)     // E biale //
  {
    digitalWrite(E_czerwone, HIGH);
    digitalWrite(E_zielone, LOW);
    digitalWrite(E_pomaranczowe, LOW);
    digitalWrite(E_biale, HIGH);
    miganie_biale_E = 1;
    Serial.println(6033);
  }

  if (data == 3034)     // E zielone + pomaranczowe //
  {
    digitalWrite(E_czerwone, LOW);
    digitalWrite(E_zielone, HIGH);
    digitalWrite(E_pomaranczowe, HIGH);
    digitalWrite(E_biale, LOW);
    miganie_biale_E = 0;
    Serial.println(6034);
  }


  // ------------------------------------------- SEMAFOR F ---------------------------- //
  if (data == 3041)   // semafor F czerwone //
  {
    digitalWrite(F_czerwone, HIGH);
    digitalWrite(F_zielone, LOW);
    digitalWrite(F_pomaranczowe_1, LOW);
    digitalWrite(F_pomaranczowe_2, LOW);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 0;
    Serial.println(6041);
  }

  if (data == 3042)   // semafor F zielone //
  {
    digitalWrite(F_czerwone, LOW);
    digitalWrite(F_zielone, HIGH);
    digitalWrite(F_pomaranczowe_1, LOW);
    digitalWrite(F_pomaranczowe_2, LOW);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 0;
    Serial.println(6042);
  }

  if (data == 3043)   // semafor F biale migajace //
  {
    digitalWrite(F_czerwone, HIGH);
    digitalWrite(F_zielone, LOW);
    digitalWrite(F_pomaranczowe_1, LOW);
    digitalWrite(F_pomaranczowe_2, LOW);
    digitalWrite(F_biale, HIGH);
    miganie_biale_F = 1;
    miganie_pomaranczowe_F = 0;
    Serial.println(6043);
  }

  if (data == 3044)   // semafor F pomaranczowe >> S5 //
  {
    digitalWrite(F_czerwone, LOW);
    digitalWrite(F_zielone, LOW);
    digitalWrite(F_pomaranczowe_1, HIGH);
    digitalWrite(F_pomaranczowe_2, LOW);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 0;
    Serial.println(6044);
  }

  if (data == 3045)   // semafor F dwa pomaranczowe >> S 13//
  {
    digitalWrite(F_czerwone, LOW);
    digitalWrite(F_zielone, LOW);
    digitalWrite(F_pomaranczowe_1, HIGH);
    digitalWrite(F_pomaranczowe_2, HIGH);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 0;
    Serial.println(6045);
  }

  if (data == 3046)   // semafor F dwa pomaranczowe górne miga >> S12 //
  {
    digitalWrite(F_czerwone, LOW);
    digitalWrite(F_zielone, LOW);
    digitalWrite(F_pomaranczowe_1, HIGH);
    digitalWrite(F_pomaranczowe_2, HIGH);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 1;
    Serial.println(6046);
  }

  if (data == 3047)   // semafor F zielone + pomaranczowe >> S10 //
  {
    digitalWrite(F_czerwone, LOW);
    digitalWrite(F_zielone, HIGH);
    digitalWrite(F_pomaranczowe_1, LOW);
    digitalWrite(F_pomaranczowe_2, HIGH);
    digitalWrite(F_biale, LOW);
    miganie_biale_F = 0;
    miganie_pomaranczowe_F = 0;
    Serial.println(6047);
  }

} // koniec bloku odczyt_seriala





// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   L O O P   ------------------------------------------------------------------------
void loop() {
  czas = millis();
  if (Serial.available() > 0)odczyt_seriala();

  if (czas_miganie < czas)
  {
    migacz++;
    if (migacz > 1)migacz = 0;
    czas_miganie = czas + 700;
  }

  if (miganie_biale_D == 1)
  {
    if (migacz == 0) digitalWrite(D_biale, LOW);
    if (migacz == 1)digitalWrite(D_biale, HIGH);
  }

  if (miganie_biale_E == 1)
  {
    if (migacz == 0) digitalWrite(E_biale, LOW);
    if (migacz == 1)digitalWrite(E_biale, HIGH);
  }

  if (miganie_biale_F == 1)
  {
    if (migacz == 0) digitalWrite(F_biale, LOW);
    if (migacz == 1)digitalWrite(F_biale, HIGH);
  }

  if (miganie_pomaranczowe_F == 1)
  {
    if (migacz == 0) digitalWrite(F_pomaranczowe_1, LOW);
    if (migacz == 1)digitalWrite(F_pomaranczowe_1, HIGH);
  }

} // koniec bloku loop
